Index: /trunk/LMDZ.PLUTO/libf/phypluto/physiq_mod.F90
===================================================================
--- /trunk/LMDZ.PLUTO/libf/phypluto/physiq_mod.F90	(revision 3194)
+++ /trunk/LMDZ.PLUTO/libf/phypluto/physiq_mod.F90	(revision 3195)
@@ -1286,8 +1350,8 @@
       zu(1:ngrid,1:nlayer) = pu(1:ngrid,1:nlayer) + pdu(1:ngrid,1:nlayer)*ptimestep
       zv(1:ngrid,1:nlayer) = pv(1:ngrid,1:nlayer) + pdv(1:ngrid,1:nlayer)*ptimestep
-      
+
       !! Recast thermal plume vertical velocity array for outputs
       !! AF24: removed
-      
+
       ! Diagnostic.
       zdtdyn(1:ngrid,1:nlayer)     = (pt(1:ngrid,1:nlayer)-ztprevious(1:ngrid,1:nlayer)) / ptimestep
@@ -1352,9 +1416,9 @@
             endif
          end do
-                     
+
          if(ngrid.eq.1)then
             DYN=0.0
          endif
-         
+
          if (is_master) then
             print*,'  ISR            ASR            OLR            GND            DYN [W m^-2]'
@@ -1412,12 +1476,24 @@
          ! Generalised for arbitrary aerosols now. By LK
          reffcol(1:ngrid,1:naerkind)=0.0
-         if(n2cond.and.(iaero_n2.ne.0))then
-            call n2_reffrad(ngrid,nlayer,nq,zq,reffrad(1,1,iaero_n2))
-            do ig=1,ngrid
-               reffcol(ig,iaero_n2) = SUM(zq(ig,1:nlayer,igcm_n2_ice)*reffrad(ig,1:nlayer,iaero_n2)*mass(ig,1:nlayer))
-            enddo
-         endif
-         ! if(water.and.(iaero_h2o.ne.0))then !AF24: removed
-         
+            ! call n2_reffrad(ngrid,nlayer,nq,zq,reffrad(1,1,iaero_haze))
+         if (haze_proffix.and.i_haze.gt.0.) then
+               call haze_prof(ngrid,nlayer,zzlay,pplay,pt, &
+                                        reffrad,profmmr)
+               zdqhaze(:,:,i_haze)=(profmmr(:,:)-pq(:,:,igcm_n2)) & ! AF: TODO: replace by igcm_haze?
+                                                        /ptimestep
+              else
+               !! AF: TODO import from pluto.old?
+               ! call hazecloud(ngrid,nlayer,nq,ptimestep,&
+               !    pplay,pplev,pq,pdq,dist_sol,mu0,zfluxuv,zdqhaze,&
+               !    zdqphot_prec,zdqphot_ch4,zdqconv_prec,declin)
+              endif
+
+         DO iq=1, nq ! should be updated
+            DO l=1,nlayer
+              DO ig=1,ngrid
+                   pdq(ig,l,iq)=pdq(ig,l,iq)+ zdqhaze(ig,l,iq)
+              ENDDO
+            ENDDO
+         ENDDO
       endif ! end of 'tracer'
 
@@ -1431,7 +1507,7 @@
 
             call generic_tracer_index(nq,iq,igcm_generic_vap,igcm_generic_ice,call_ice_vap_generic)
-            
+
             if (call_ice_vap_generic) then ! to call only one time the ice/vap pair of a tracer
-      
+
                do l = 1, nlayer
                   do ig=1,ngrid
@@ -1442,5 +1518,5 @@
 
             end if
-         
+
          end do ! iq=1,nq
 
@@ -1449,6 +1525,6 @@
 
       if (is_master) print*,'--> Ls =',zls*180./pi
-      
-      
+
+
 !----------------------------------------------------------------------
 !        Writing NetCDF file  "RESTARTFI" at the end of the run
@@ -1468,11 +1544,11 @@
          !! Update surface ice distribution to iterate to steady state if requested
          !! AF24: removed
-         
+
          ! endif
 #ifndef MESOSCALE
-         
+
          if (ngrid.ne.1) then
             write(*,*)'PHYSIQ: for physdem ztime_fin =',ztime_fin
-            
+
             call physdem1("restartfi.nc",nsoilmx,ngrid,nlayer,nq, &
                           ptimestep,ztime_fin,                    &
@@ -1493,5 +1569,5 @@
 !  which can later be used to make the statistic files of the run:
 !  if flag "callstats" from callphys.def is .true.)
-         
+
 
          call wstats(ngrid,"ps","Surface pressure","Pa",2,ps)
@@ -1503,8 +1579,8 @@
                      "Thermal IR radiative flux to space","W.m-2",2,    &
                      fluxtop_lw)
-                     
+
 !            call wstats(ngrid,"fluxsurf_sw",                               &
 !                        "Solar radiative flux to surface","W.m-2",2,       &
-!                         fluxsurf_sw_tot)                     
+!                         fluxsurf_sw_tot)
 !            call wstats(ngrid,"fluxtop_sw",                                &
 !                        "Solar radiative flux to space","W.m-2",2,         &
@@ -1527,16 +1603,16 @@
             do iq=1,nq
                call wstats(ngrid,noms(iq),noms(iq),'kg/kg',3,zq(1,1,iq))
-               call wstats(ngrid,trim(noms(iq))//'_surf',trim(noms(iq))//'_surf',  & 
+               call wstats(ngrid,trim(noms(iq))//'_surf',trim(noms(iq))//'_surf',  &
                            'kg m^-2',2,qsurf(1,iq) )
-               call wstats(ngrid,trim(noms(iq))//'_col',trim(noms(iq))//'_col',    & 
+               call wstats(ngrid,trim(noms(iq))//'_col',trim(noms(iq))//'_col',    &
                           'kg m^-2',2,qcol(1,iq) )
-                          
-!              call wstats(ngrid,trim(noms(iq))//'_reff',                          & 
-!                          trim(noms(iq))//'_reff',                                   & 
+
+!              call wstats(ngrid,trim(noms(iq))//'_reff',                          &
+!                          trim(noms(iq))//'_reff',                                   &
 !                          'm',3,reffrad(1,1,iq))
 
             end do
-            
-         endif ! end of 'tracer' 
+
+         endif ! end of 'tracer'
 
          !AF24: deleted slab ocean and water
@@ -1546,8 +1622,8 @@
             call mkstats(ierr)
          endif
-         
+
 
 #ifndef MESOSCALE
-       
+
 !-----------------------------------------------------------------------------------------------------
 !           OUTPUT in netcdf file "DIAGFI.NC", containing any variable for diagnostic
@@ -1577,12 +1653,12 @@
 
 !       ! Oceanic layers !AF24: removed
-      
+
       ! ! Thermal plume model  !AF24: removed
-      
+
 !        GW non-oro outputs  !AF24: removed
-      
+
       ! Total energy balance diagnostics
       if(callrad)then
-      
+
          !call writediagfi(ngrid,"ALB","Surface albedo"," ",2,albedo_equivalent)
          !call writediagfi(ngrid,"ALB_1st","First Band Surface albedo"," ",2,albedo(:,1))
@@ -1591,5 +1667,5 @@
          call writediagfi(ngrid,"OLR","outgoing longwave rad.","W m-2",2,fluxtop_lw)
          call writediagfi(ngrid,"shad","rings"," ", 2, fract)
-         
+
 !           call writediagfi(ngrid,"ASRcs","absorbed stellar rad (cs).","W m-2",2,fluxabs_sw1)
 !           call writediagfi(ngrid,"OLRcs","outgoing longwave rad (cs).","W m-2",2,fluxtop_lw1)
@@ -1604,27 +1680,27 @@
          call writediagfi(ngrid,"GND","heat flux from ground","W m-2",2,fluxgrd)
          ! endif
-         
+
          call writediagfi(ngrid,"DYN","dynamical heat input","W m-2",2,fluxdyn)
-         
+
       endif ! end of 'callrad'
-        
+
       if(enertest) then
-      
+
          if (calldifv) then
-         
+
             call writediagfi(ngrid,"q2","turbulent kinetic energy","J.kg^-1",3,q2)
             call writediagfi(ngrid,"sensibFlux","sensible heat flux","w.m^-2",2,sensibFlux)
-            
+
 !             call writediagfi(ngrid,"dEzdiff","turbulent diffusion heating (-sensible flux)","w.m^-2",3,dEzdiff)
 !             call writediagfi(ngrid,"dEdiff","integrated turbulent diffusion heating (-sensible flux)","w.m^-2",2,dEdiff)
 !             call writediagfi(ngrid,"dEdiffs","In TurbDiff (correc rad+latent heat) surf nrj change","w.m^-2",2,dEdiffs)
-             
-         endif
-          
+
+         endif
+
          if (corrk) then
             call writediagfi(ngrid,"dEzradsw","radiative heating","w.m^-2",3,dEzradsw)
             call writediagfi(ngrid,"dEzradlw","radiative heating","w.m^-2",3,dEzradlw)
          endif
-          
+
 !          if(watercond) then  !AF24: removed
 
@@ -1633,12 +1709,12 @@
             call writediagfi(ngrid,"genericconddE","heat from generic condensation","W m-2",2,genericconddE)
             call writediagfi(ngrid,"dt_generic_condensation","heating from generic condensation","K s-1",3,dt_generic_condensation)
-         
-         endif
-          
+
+         endif
+
       endif ! end of 'enertest'
 
         ! Diagnostics of optical thickness
         ! Warning this is exp(-tau), I let you postproc with -log to have tau itself - JVO 19
-        if (diagdtau) then                
+        if (diagdtau) then
           do nw=1,L_NSPECTV
             write(str2,'(i2.2)') nw
@@ -1657,31 +1733,31 @@
         call writediagfi(ngrid,"dtrad","radiative heating","K s-1",3,dtrad)
         call writediagfi(ngrid,"zdtdyn","Dyn. heating","T s-1",3,zdtdyn)
-        
+
         ! For Debugging.
         !call writediagfi(ngrid,'rnat','Terrain type',' ',2,real(rnat))
         !call writediagfi(ngrid,'pphi','Geopotential',' ',3,pphi)
-        
-
-      ! Output aerosols.
-      if (igcm_n2_ice.ne.0.and.iaero_n2.ne.0) &
-         call writediagfi(ngrid,'N2ice_reff','N2ice_reff','m',3,reffrad(1,1,iaero_n2))
-      if (igcm_n2_ice.ne.0.and.iaero_n2.ne.0) &
-         call writediagfi(ngrid,'N2ice_reffcol','N2ice_reffcol','um kg m^-2',2,reffcol(1,iaero_n2))
+
+
+      ! Output aerosols.!AF: TODO: write haze aerosols
+      ! if (igcm_n2_ice.ne.0.and.iaero_haze.ne.0) &
+      !    call writediagfi(ngrid,'N2ice_reff','N2ice_reff','m',3,reffrad(1,1,iaero_haze))
+      ! if (igcm_n2_ice.ne.0.and.iaero_haze.ne.0) &
+      !    call writediagfi(ngrid,'N2ice_reffcol','N2ice_reffcol','um kg m^-2',2,reffcol(1,iaero_haze))
       ! if (igcm_h2o_ice.ne.0.and.iaero_h2o.ne.0) &  !AF24: removed
-      
+
       ! Output tracers.
       if (tracer) then
-      
+
          do iq=1,nq
             call writediagfi(ngrid,noms(iq),noms(iq),'kg/kg',3,zq(1,1,iq))
-            call writediagfi(ngrid,trim(noms(iq))//'_surf',trim(noms(iq))//'_surf',  & 
+            call writediagfi(ngrid,trim(noms(iq))//'_surf',trim(noms(iq))//'_surf',  &
                              'kg m^-2',2,qsurf_hist(1,iq) )
-            call writediagfi(ngrid,trim(noms(iq))//'_col',trim(noms(iq))//'_col',    & 
+            call writediagfi(ngrid,trim(noms(iq))//'_col',trim(noms(iq))//'_col',    &
                             'kg m^-2',2,qcol(1,iq) )
-!          call writediagfi(ngrid,trim(noms(iq))//'_surf',trim(noms(iq))//'_surf',  & 
-!                          'kg m^-2',2,qsurf(1,iq) )                          
+!          call writediagfi(ngrid,trim(noms(iq))//'_surf',trim(noms(iq))//'_surf',  &
+!                          'kg m^-2',2,qsurf(1,iq) )
 
             ! if(watercond.or.CLFvarying)then  !AF24: removed
-            
+
             if(generic_condensation)then
                call writediagfi(ngrid,"rneb_generic","GCS cloud fraction (generic condensation)"," ",3,rneb_generic)
@@ -1692,14 +1768,14 @@
             ! if(generic_rain)then  !AF24: removed
             ! if((hydrology).and.(.not.ok_slab_ocean))then  !AF24: removed
-            
+
             call writediagfi(ngrid,"tau_col","Total aerosol optical depth","[]",2,tau_col)
 
          enddo ! end of 'nq' loop
-         
+
        endif ! end of 'tracer'
 
 
       ! Output spectrum.
-      if(specOLR.and.corrk)then      
+      if(specOLR.and.corrk)then
          call writediagspecIR(ngrid,"OLR3D","OLR(lon,lat,band)","W/m^2/cm^-1",3,OLR_nu)
          call writediagspecVI(ngrid,"OSR3D","OSR(lon,lat,band)","W/m^2/cm^-1",3,OSR_nu)
@@ -1713,5 +1789,5 @@
    if (.not.calldifv) comm_LATENT_HF(:)=0.0
    ! if ((tracer).and.(water)) then  !AF24: removed
-   
+
    if ((tracer).and.(generic_condensation)) then
    ! .and.(.not. water)
@@ -1724,5 +1800,5 @@
       do iq=1,nq
          call generic_tracer_index(nq,iq,igcm_generic_vap,igcm_generic_ice,call_ice_vap_generic)
-                  
+
          if (call_ice_vap_generic) then ! to call only one time the ice/vap pair of a tracer
 
@@ -1741,6 +1817,6 @@
             comm_RH(1:ngrid,1:nlayer) = RH_generic(1:ngrid,1:nlayer,iq)
 
-         endif 
-      end do ! do iq=1,nq loop on tracers 
+         endif
+      end do ! do iq=1,nq loop on tracers
 
    else
@@ -1785,9 +1861,9 @@
 
 ! XIOS outputs
-#ifdef CPP_XIOS      
+#ifdef CPP_XIOS
       ! Send fields to XIOS: (NB these fields must also be defined as
       ! <field id="..." /> in context_lmdz_physics.xml to be correctly used)
       CALL send_xios_field("ls",zls)
-      
+
       CALL send_xios_field("ps",ps)
       CALL send_xios_field("area",cell_area)
@@ -1797,13 +1873,13 @@
       CALL send_xios_field("v",zv)
       CALL send_xios_field("omega",omega)
-      
+
 !       IF (calltherm) THEN  !AF24: removed
       ! IF (water) THEN  !AF24: removed
-      
+
       CALL send_xios_field("ISR",fluxtop_dn)
       CALL send_xios_field("OLR",fluxtop_lw)
       CALL send_xios_field("ASR",fluxabs_sw)
 
-      if (specOLR .and. corrk) then 
+      if (specOLR .and. corrk) then
          call send_xios_field("OLR3D",OLR_nu)
          call send_xios_field("IR_Bandwidth",DWNI)
@@ -1818,5 +1894,5 @@
       endif
 #endif
-      
+
       if (check_physics_outputs) then
          ! Check the validity of updated fields at the end of the physics step
@@ -1825,6 +1901,6 @@
 
       icount=icount+1
-      
+
       end subroutine physiq
-      
+
    end module physiq_mod
Index: /trunk/LMDZ.PLUTO/libf/phypluto/radii_mod.F90
===================================================================
--- /trunk/LMDZ.PLUTO/libf/phypluto/radii_mod.F90	(revision 3194)
+++ /trunk/LMDZ.PLUTO/libf/phypluto/radii_mod.F90	(revision 3195)
@@ -4,5 +4,5 @@
 !  module to centralize the radii calculations for aerosols
 !==================================================================
-      
+
 !     N2 cloud properties (initialized in inifis)
       real,save :: Nmix_n2 ! Number mixing ratio of N2 ice particles
@@ -21,13 +21,6 @@
 !     Purpose
 !     -------
-!     Compute the effective radii of liquid and icy water particles
-!     Jeremy Leconte (2012)
-!     Extended to dust, N2, NH3, 2-lay,Nlay,auroral aerosols by ??
-!     Added Radiative Generic Condensable Species effective radii
-!     calculations  (Lucas Teinturier 2022)
+!     Compute the effective radii of haze particles  (TB)
 !
-!     Authors
-!     -------
-!     Jeremy Leconte (2012)
 !
 !==================================================================
@@ -35,10 +28,9 @@
       use ioipsl_getin_p_mod, only: getin_p
       use radinc_h, only: naerkind
-      use aerosol_mod, only: iaero_back2lay, iaero_n2, iaero_dust, &
-                             iaero_h2so4, iaero_nh3, iaero_nlay, &
-                             iaero_aurora, iaero_generic, i_rgcs_ice
-      use callkeys_mod, only: size_nh3_cloud, nlayaero, aeronlay_size, &
+      use aerosol_mod, only: iaero_haze, i_haze, &
+                              iaero_generic, i_rgcs_ice
+      use callkeys_mod, only: nlayaero, aeronlay_size, &
                               aeronlay_nueff,aerogeneric
-      use tracer_h, only: radius, nqtot, is_rgcs
+      use tracer_h, only: radius, nqtot, is_rgcs, nmono
       Implicit none
 
@@ -47,64 +39,18 @@
 
       real, intent(out) :: reffrad(ngrid,nlayer,naerkind)      !aerosols radii (K)
-      real, intent(out) :: nueffrad(ngrid,nlayer,naerkind)     !variance     
+      real, intent(out) :: nueffrad(ngrid,nlayer,naerkind)     !variance
 
-      logical, save :: firstcall=.true.
-!$OMP THREADPRIVATE(firstcall)
-      integer :: iaer, ia , iq, i_rad  
+      integer :: iaer, ia , iq, i_rad
 
       do iaer=1,naerkind
-!     these values will change once the microphysics gets to work
-!     UNLESS tracer=.false., in which case we should be working with
-!     a fixed aerosol layer, and be able to define reffrad in a 
-!     .def file. To be improved!
-!                |-> Done in th n-layer aerosol case (JVO 20)
-
-         if(iaer.eq.iaero_n2)then ! N2 ice
-            reffrad(1:ngrid,1:nlayer,iaer) = 1.e-4
-            nueffrad(1:ngrid,1:nlayer,iaer) = 0.1 
+         print*, 'TB22 iaer',iaer,iaero_haze
+         if(iaer.eq.iaero_haze)then
+           ! Equivalent sphere radius
+           reffrad(1:ngrid,1:nlayer,iaer)=radius(i_haze)*nmono**(1./3.)
+           !reffrad(1:ngrid,1:nlayer,iaer) = 2.e-6 ! haze
+           nueffrad(1:ngrid,1:nlayer,iaer) = 0.02 ! haze
+           print*, 'TB22 Hello2',radius(i_haze)*nmono**(1./3.)
          endif
-
-         if(iaer.eq.iaero_dust)then ! dust
-            reffrad(1:ngrid,1:nlayer,iaer) = 1.e-5
-            nueffrad(1:ngrid,1:nlayer,iaer) = 0.1 
-         endif
- 
-         if(iaer.eq.iaero_h2so4)then ! H2SO4 ice
-            reffrad(1:ngrid,1:nlayer,iaer) = 1.e-6
-            nueffrad(1:ngrid,1:nlayer,iaer) = 0.1 
-         endif
-            
-         if(iaer.eq.iaero_back2lay)then ! Two-layer aerosols
-            reffrad(1:ngrid,1:nlayer,iaer) = 2.e-6
-            nueffrad(1:ngrid,1:nlayer,iaer) = 0.1 
-         endif
-
-
-	 if(iaer.eq.iaero_nh3)then ! Nh3 cloud
-            reffrad(1:ngrid,1:nlayer,iaer) = size_nh3_cloud
-            nueffrad(1:ngrid,1:nlayer,iaer) = 0.1 
-         endif
-
-         do ia=1,nlayaero
-            if(iaer.eq.iaero_nlay(ia))then ! N-layer aerosols
-               reffrad(1:ngrid,1:nlayer,iaer) = aeronlay_size(ia)
-               nueffrad(1:ngrid,1:nlayer,iaer) = aeronlay_nueff(ia) 
-            endif
-         enddo
-
-	 if(iaer.eq.iaero_aurora)then ! Auroral aerosols
-            reffrad(1:ngrid,1:nlayer,iaer) = 3.e-7
-            nueffrad(1:ngrid,1:nlayer,iaer) = 0.1 
-         endif
-
-         do ia=1,aerogeneric     ! Radiative Generic Condensable Species
-            if (iaer .eq. iaero_generic(ia)) then 
-               i_rad = i_rgcs_ice(ia)
-               reffrad(1:ngrid,1:nlayer,iaer)=radius(i_rad)
-               nueffrad(1:ngrid,1:nlayer,iaer) = 0.1
-            endif 
-         enddo  ! generic radiative condensable aerosols
-         
-      enddo ! iaer=1,naerkind
+      enddo
 
    end subroutine su_aer_radii
@@ -113,137 +59,76 @@
 
 !==================================================================
-   subroutine n2_reffrad(ngrid,nlayer,nq,pq,reffrad)
-!==================================================================
+   subroutine haze_reffrad_fix(ngrid,nlayer,zzlay,reffrad,nueffrad)
+      !==================================================================
 !     Purpose
 !     -------
-!     Compute the effective radii of n2 ice particles !AF24: copied from CO2
-!
-!     Authors
-!     -------
-!     Jeremy Leconte (2012)
+!     Compute the effective radii of haze particles
+!     fixed profile of radius (TB)
 !
 !==================================================================
-      USE tracer_h, only:igcm_n2_ice,rho_n2
+      use radinc_h, only: naerkind
+      USE tracer_h, only:rho_n2,nmono
       use comcstfi_mod, only: pi
+      use aerosol_mod, only: iaero_haze, i_haze
+      use datafile_mod
       Implicit none
 
-      integer,intent(in) :: ngrid,nlayer,nq
+      integer,intent(in) :: ngrid,nlayer
+      real,intent(in) :: zzlay(ngrid,nlayer)
+      real, intent(out) :: reffrad(ngrid,nlayer,naerkind)      ! haze particles radii (m)
+      real, intent(out) :: nueffrad(ngrid,nlayer,naerkind)     !
 
-      real, intent(in) :: pq(ngrid,nlayer,nq) !tracer mixing ratios (kg/kg)
-      real, intent(out) :: reffrad(ngrid,nlayer)      !n2 ice particles radii (m)
+      real :: zrad
+      real,external :: CBRT
 
-      integer :: ig,l
-      real :: zrad   
-      real,external :: CBRT            
-            
-      
+      logical, save :: firstcall=.true.
+      !$OMP THREADPRIVATE(firstcall)
 
-      if (radfixed) then
-         reffrad(1:ngrid,1:nlayer) = 5.e-5 ! N2 ice
-      else
-         do l=1,nlayer
-            do ig=1,ngrid
-               zrad = CBRT( 3*pq(ig,l,igcm_n2_ice)/(4*Nmix_n2*pi*rho_n2) )
-               reffrad(ig,l) = min(max(zrad,1.e-6),100.e-6)
-            enddo
-         enddo      
-      end if
+!     Local variables
+      integer :: iaer,l,ifine,ig
+      real :: radvec(ngrid,nlayer)
 
-   end subroutine n2_reffrad
+      !!read altitudes and radius
+      integer Nfine
+      !parameter(Nfine=21)
+      parameter(Nfine=701)
+      character(len=100) :: file_path
+      real,save :: levdat(Nfine),raddat(Nfine)
+
+!---------------- INPUT ------------------------------------------------
+
+      IF (firstcall) then
+         firstcall=.false.
+         file_path=trim(datadir)//'/haze_prop/hazerad.txt'
+         open(223,file=file_path,form='formatted')
+         do ifine=1,Nfine
+            read(223,*) levdat(ifine), raddat(ifine)
+         enddo
+         close(223)
+         print*, 'TB22 READ HAZERAD'
+       ENDIF
+
+       ! in radii mod levs has been put in km
+       DO ig=1,ngrid
+         CALL interp_line(levdat,raddat,Nfine,zzlay(ig,:)/1000,radvec(ig,:),nlayer)
+       enddo
+
+       do iaer=1,naerkind
+             if(iaer.eq.iaero_haze)then
+                  ! spherical radius or eq spherical radius
+                  ! TB22: fractal has no impact on reffrad if haze_radproffix
+                  do ig=1,ngrid
+                     do l=1,nlayer
+                        reffrad(ig,l,iaer)=radvec(ig,l)*1.e-9    !  nm => m
+                     enddo
+                  enddo
+                  nueffrad(1:ngrid,1:nlayer,iaer) = 0.02 ! haze
+             endif
+       enddo
+
+   end subroutine haze_reffrad_fix
 !==================================================================
 
 
-
-!==================================================================
-   subroutine dust_reffrad(ngrid,nlayer,reffrad)
-!==================================================================
-!     Purpose
-!     -------
-!     Compute the effective radii of dust particles
-!
-!     Authors
-!     -------
-!     Jeremy Leconte (2012)
-!
-!==================================================================
-      Implicit none
-
-      integer,intent(in) :: ngrid
-      integer,intent(in) :: nlayer
-
-      real, intent(out) :: reffrad(ngrid,nlayer)      !dust particles radii (m)
-            
-      reffrad(1:ngrid,1:nlayer) = 2.e-6 ! dust
-
-   end subroutine dust_reffrad
-!==================================================================
-
-
-!==================================================================
-   subroutine h2so4_reffrad(ngrid,nlayer,reffrad)
-!==================================================================
-!     Purpose
-!     -------
-!     Compute the effective radii of h2so4 particles
-!
-!     Authors
-!     -------
-!     Jeremy Leconte (2012)
-!
-!==================================================================
-      Implicit none
-
-      integer,intent(in) :: ngrid
-      integer,intent(in) :: nlayer
-
-      real, intent(out) :: reffrad(ngrid,nlayer)      !h2so4 particle radii (m)
-                
-      reffrad(1:ngrid,1:nlayer) = 1.e-6 ! h2so4
-
-   end subroutine h2so4_reffrad
-!==================================================================
-
-!==================================================================
-   subroutine back2lay_reffrad(ngrid,reffrad,nlayer,pplev)
-!==================================================================
-!     Purpose
-!     -------
-!     Compute the effective radii of particles in a 2-layer model
-!
-!     Authors
-!     -------
-!     Sandrine Guerlet (2013)
-!
-!==================================================================
-      use callkeys_mod, only: pres_bottom_tropo,pres_top_tropo,size_tropo,  &
-                              pres_bottom_strato,size_strato
- 
-      Implicit none
-
-      integer,intent(in) :: ngrid
-
-      real, intent(out) :: reffrad(ngrid,nlayer)      ! particle radii (m)
-      REAL,INTENT(IN) :: pplev(ngrid,nlayer+1) ! inter-layer pressure (Pa)
-      INTEGER,INTENT(IN) :: nlayer ! number of atmospheric layers
-      REAL :: expfactor
-      INTEGER l,ig
-            
-      reffrad(:,:)=1e-6  !!initialization, not important
-          DO ig=1,ngrid
-            DO l=1,nlayer-1
-              IF (pplev(ig,l) .le. pres_bottom_tropo .and. pplev(ig,l) .ge. pres_top_tropo) THEN
-                reffrad(ig,l) = size_tropo
-              ELSEIF (pplev(ig,l) .lt. pres_top_tropo .and. pplev(ig,l) .gt. pres_bottom_strato) THEN
-                expfactor=log(size_strato/size_tropo) / log(pres_bottom_strato/pres_top_tropo)
-                reffrad(ig,l)= size_tropo*((pplev(ig,l)/pres_top_tropo)**expfactor)
-              ELSEIF (pplev(ig,l) .le. pres_bottom_strato) then
-                reffrad(ig,l) = size_strato
-              ENDIF
-            ENDDO
-          ENDDO
-
-   end subroutine back2lay_reffrad
-!==================================================================
-
 end module radii_mod
 !==================================================================
Index: /trunk/LMDZ.PLUTO/libf/phypluto/suaer_corrk.F90
===================================================================
--- /trunk/LMDZ.PLUTO/libf/phypluto/suaer_corrk.F90	(revision 3194)
+++ /trunk/LMDZ.PLUTO/libf/phypluto/suaer_corrk.F90	(revision 3195)
@@ -16,12 +16,10 @@
       use radcommon_h, only: radiustab,nsize,tstellar
       use radcommon_h, only: qrefvis,qrefir,omegarefir !,omegarefvis
-      use aerosol_mod, only: noaero,iaero_n2,iaero_dust,iaero_h2so4
-      use aerosol_mod, only: iaero_back2lay,iaero_nh3,iaero_nlay,iaero_aurora
-      use aerosol_mod, only: iaero_generic,i_rgcs_ice
+      use aerosol_mod, only: noaero,iaero_haze
       use callkeys_mod, only: tplanet, optprop_back2lay_vis, optprop_back2lay_ir, &
                               optprop_aeronlay_vis, optprop_aeronlay_ir,          &
                               aeronlay_lamref, nlayaero,aerogeneric
       use tracer_h, only: noms
-      
+
       use mod_phys_lmdz_para, only : is_master, bcast
 
@@ -41,7 +39,7 @@
 !     omeg(nwvl)                     omegav   omegavis(L_NSPECTV)
 !     gfactor(nwvl)                  gav      gvis(L_NSPECTV)
-!     
+!
 !     Authors
-!     ------- 
+!     -------
 !     Richard Fournier (1996) Francois Forget (1996)
 !     Frederic Hourdin
@@ -54,5 +52,5 @@
 !     - Add water ice clouds
 !     MODIF R. Wordsworth (2009)
-!     - generalisation to arbitrary spectral bands 
+!     - generalisation to arbitrary spectral bands
 !
 !==================================================================
@@ -100,5 +98,5 @@
       REAL omegavIR(L_NSPECTI)          ! Average single scattering albedo
       REAL gavIR(L_NSPECTI)             ! Average assymetry parameter
-      
+
       logical forgetit                  ! use francois' data?
       integer iwvl, ia
@@ -109,5 +107,5 @@
 
 !---- Please indicate the names of the optical property files below
-!     Please also choose the reference wavelengths of each aerosol      
+!     Please also choose the reference wavelengths of each aerosol
 
 !--------- README TO UNDERSTAND WHAT FOLLOWS (JVO 20) -------
@@ -136,11 +134,11 @@
         print*, 'naerkind= 0'
       endif
-      
-      
+
+
       do iaer=1,naerkind
          !     naerkind=1: haze
          if (iaer.eq.1) then
 
-         ! Only one table of optical properties : 
+         ! Only one table of optical properties :
          write(*,*)'Suaer haze optical properties, using: ', &
                            TRIM(hazeprop)
@@ -150,10 +148,10 @@
          ! infrared
          file_id(iaer,2)=file_id(iaer,1)
-         
+
          lamrefvis(iaer)=0.607E-6   ! reference wavelength for opacity vis pivot wavelength Cheng et al 2017
          lamrefir(iaer)=2.E-6   !  reference wavelength for opacity IR (in the LEISA range)
 
          endif
-      enddo   
+      enddo
 
       IF (naerkind .gt. 1) THEN
@@ -162,5 +160,5 @@
          call abort
       ENDIF
-      
+
 !------------------------------------------------------------------
 
@@ -185,5 +183,5 @@
 !!!!$OMP MASTER
       if (is_master) then
-          
+
             INQUIRE(FILE=TRIM(datadir)//'/'//TRIM(aerdir)//&
                     '/'//TRIM(file_id(iaer,idomain)),&
@@ -205,5 +203,5 @@
                           '/'//TRIM(file_id(iaer,idomain)),&
                      FORM='formatted')
-              ENDIF              
+              ENDIF
             ENDIF
             IF(.NOT.file_ok) THEN
@@ -220,5 +218,5 @@
                write(*,*)' http://www.lmd.jussieu.fr/',&
                '~lmdz/planets/LMDZ.GENERIC/datagcm/'
-               CALL ABORT 
+               CALL ABORT
             ENDIF
 
@@ -239,8 +237,8 @@
                read(file_unit,*) nsize(iaer,idomain)
                endwhile = .true.
-            CASE DEFAULT reading1_seq ! ---------------------------- 
-               WRITE(*,*) 'readoptprop: ',& 
-               'Error while loading optical properties.' 
-               CALL ABORT 
+            CASE DEFAULT reading1_seq ! ----------------------------
+               WRITE(*,*) 'readoptprop: ',&
+               'Error while loading optical properties.'
+               CALL ABORT
             END SELECT reading1_seq ! ==============================
          ENDIF
@@ -256,5 +254,5 @@
       ALLOCATE(radiusdyn(nsize(iaer,idomain))) ! radiusdyn
       ALLOCATE(ep(nwvl,nsize(iaer,idomain))) ! ep
-      ALLOCATE(omeg(nwvl,nsize(iaer,idomain))) ! omeg 
+      ALLOCATE(omeg(nwvl,nsize(iaer,idomain))) ! omeg
       ALLOCATE(gfactor(nwvl,nsize(iaer,idomain))) ! g
 
@@ -316,5 +314,5 @@
 
       jfile = jfile+1
-      IF ((idomain.NE.iaero_n2).OR.(iaer.NE.iaero_n2)) THEN
+      IF ((idomain.NE.iaero_haze).OR.(iaer.NE.iaero_haze)) THEN
          endwhile = .true.
       ENDIF
@@ -334,5 +332,5 @@
 
 !     1.5 If Francois' data, convert wvl to metres
-       if(iaer.eq.iaero_n2)then
+       if(iaer.eq.iaero_haze)then
          if(forgetit)then
          !   print*,'please sort out forgetit for naerkind>1'
@@ -440,6 +438,6 @@
       DEALLOCATE(wvl)             ! wvl
       DEALLOCATE(radiusdyn)       ! radiusdyn
-      DEALLOCATE(ep)              ! ep 
-      DEALLOCATE(omeg)            ! omeg 
+      DEALLOCATE(ep)              ! ep
+      DEALLOCATE(omeg)            ! omeg
       DEALLOCATE(gfactor)         ! g
 
@@ -447,9 +445,9 @@
   END DO                    ! Loop on idomain
 !========================================================================
- 
+
   ! cleanup
   deallocate(file_id)
 
 end subroutine suaer_corrk
-      
+
 end module suaer_corrk_mod
Index: /trunk/LMDZ.PLUTO/libf/phypluto/surfdat_h.F90
===================================================================
--- /trunk/LMDZ.PLUTO/libf/phypluto/surfdat_h.F90	(revision 3194)
+++ /trunk/LMDZ.PLUTO/libf/phypluto/surfdat_h.F90	(revision 3195)
@@ -16,4 +16,17 @@
        real,allocatable,dimension(:) :: zmea,zstd,zsig,zgam,zthe
 !$OMP THREADPRIVATE(zmea,zstd,zsig,zgam,zthe)
+       real ttop
+       real,allocatable,dimension(:) :: kp ! TB ref pressure 
+       real p00
+!$OMP THREADPRIVATE(ttop,kp,p00)
+! surface properties ! TB16
+       real alb_n2b,alb_n2a,alb_ch4,alb_co,alb_tho,emis_n2b,emis_n2a
+!$OMP THREADPRIVATE(alb_n2b,alb_n2a,alb_ch4,alb_co,alb_tho,emis_n2b,emis_n2a)       
+       real emis_ch4,emis_co,emis_tho,emis_tho_eq,alb_tho_eq,alb_ch4_eq
+!$OMP THREADPRIVATE(emis_ch4,emis_co,emis_tho,emis_tho_eq,alb_tho_eq,alb_ch4_eq)       
+       real ITN2,ITCH4,ITH2O,ITN2d,ITCH4d,ITH2Od,alb_ch4_s,albspe,emispe
+!$OMP THREADPRIVATE(ITN2,ITCH4,ITH2O,ITN2d,ITCH4d,ITH2Od,alb_ch4_s,albspe,emispe)       
+       real alb_tho_spe,emis_tho_spe
+!$OMP THREADPRIVATE(alb_tho_spe,emis_tho_spe)       
 
        real,allocatable,dimension(:) :: dryness  !"Dryness coefficient" for grnd water ice sublimation
